#ifndef _WMVARS_H

#define _WMVARS_H

#include <stdio.h>
#include <time.h>

#include <windows.h>

/* aliases */

struct wmAlias {
  char *aliasName;
  char *aliasAddr;
  struct wmAlias *nextAlias;
};

struct wmAlias *wmFirstAlias;
struct wmAlias *wmLastAlias;

struct wmAlias *wm_findAlias(char *name);


/* 'set' option types */
#define WMOPT_BOOL 0
#define WMOPT_ASK 1
#define WMOPT_STR 2
#define WMOPT_INT 3
/* and values */
#define WMOPTVAL_NO 0
#define WMOPTVAL_YES 1
#define WMOPTVAL_ASKNO 2
#define WMOPTVAL_ASKYES 3

/* set options */
struct wmOption {
  char *optionName;
  short optionType;

  union {
    int optionNumValue;
    char *optionStrValue;
  } optionValue;
};

struct wmOption wmOptions[];

struct wmOption *wm_findOpt(char *name);
char *wm_getStrOpt(struct wmOption *opt);
void wm_setStrOpt(struct wmOption *opt, char *value);


/* mailbox data */

struct wmMail {
  fpos_t mailPtr;
  char *mailFromName;
  char *mailFromAddr;
  char *mailSubj;
  int mailSize;
  time_t recvDate; /* the 'From ' header */
  time_t sentDate; /* the 'Date:' header */
  /* flags, too */
  struct wmMail *nextMail;
};

struct wmMail *wmFirstMail;
struct wmMail *wmLastMail;


/* colours */

struct wmColourInfo {
  WORD colourNum;
  char *colPattern;
};

#define WMNUMOFCOLS 17

struct wmColourInfo wmColours[WMNUMOFCOLS]; /* initialise to something sensible */

#define WMATTACHCOL      0
#define WMBODYCOL        1
#define WMBOLDCOL        2
#define WMERRORCOL       3
#define WMHEADERCOL      4
#define WMHDRDEFCOL      5
#define WMINDEXCOL       6
#define WMINDICATORCOL   7
#define WMMARKERSCOL     8
#define WMMESSAGECOL     9
#define WMNORMALCOL      10
#define WMQUOTEDCOL      11
#define WMSEARCHCOL      12
#define WMSIGCOL         13
#define WMSTATUSCOL      14
#define WMTREECOL        15
#define WMUNDERLINECOL   16

#define WMCOL_FGBLACK    0
#define WMCOL_FGRED      FOREGROUND_RED
#define WMCOL_FGGREEN    FOREGROUND_GREEN
#define WMCOL_FGYELLOW   (FOREGROUND_RED | FOREGROUND_GREEN)
#define WMCOL_FGBLUE     FOREGROUND_BLUE
#define WMCOL_FGMAGENTA  (FOREGROUND_RED | FOREGROUND_BLUE)
#define WMCOL_FGCYAN     (FOREGROUND_GREEN | FOREGROUND_BLUE)
#define WMCOL_FGWHITE    (FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE)
   WORD WMCOL_FGDEFAULT; /* assigned later */
#define WMCOL_FGBRIGHT   FOREGROUND_INTENSITY

#define WMCOL_BGBLACK    0
#define WMCOL_BGRED      BACKGROUND_RED
#define WMCOL_BGGREEN    BACKGROUND_GREEN
#define WMCOL_BGYELLOW   (BACKGROUND_RED | BACKGROUND_GREEN)
#define WMCOL_BGBLUE     BACKGROUND_BLUE
#define WMCOL_BGMAGENTA  (BACKGROUND_RED | BACKGROUND_BLUE)
#define WMCOL_BGCYAN     (BACKGROUND_GREEN | BACKGROUND_BLUE)
#define WMCOL_BGWHITE    (BACKGROUND_RED | BACKGROUND_GREEN | BACKGROUND_BLUE)
   WORD WMCOL_BGDEFAULT; /* assigned later */
#define WMCOL_BGBRIGHT   BACKGROUND_INTENSITY

#endif
